(function() {
  var ajaxFile, ajaxFiles, fn, isDocumentReady, maybeLoadedAjaxData, processAjaxData, state;

  isDocumentReady = false;

  ajaxFiles = {
    'labels.default.yml': {
      loaded: false
    },
    'labels.overwrite.yml': {
      loaded: false,
      optional: true
    },
    'settings.default.yml': {
      loaded: false
    },
    'settings.overwrite.yml': {
      loaded: false,
      optional: true
    }
  };

  processAjaxData = function() {
    var defaultLabels, errorText, overwriteLabels, overwriteLabelsDoc, overwriteSettings, overwriteSettingsDoc;
    try {
      defaultLabels = jsyaml.load(ajaxFiles['labels.default.yml'].content);
    } catch (error) {
      errorText = "Error: labels.default.yml does not contain valid YAML.";
      alert(errorText);
      throw errorText;
    }
    ELA.labels = flattenObject(defaultLabels);
    overwriteLabelsDoc = ajaxFiles['labels.overwrite.yml'].content;
    if (overwriteLabelsDoc) {
      try {
        overwriteLabels = jsyaml.load(overwriteLabelsDoc);
        flattenObject(overwriteLabels, ELA.labels);
      } catch (error) {
        alert("Warning: labels.overwrite.yml does not contain valid YAML.");
      }
    }
    try {
      ELA.settings = jsyaml.load(ajaxFiles['settings.default.yml'].content);
    } catch (error) {
      errorText = "Error: settings.default.yml does not contain valid YAML.";
      alert(errorText);
      throw errorText;
    }
    overwriteSettingsDoc = ajaxFiles['settings.overwrite.yml'].content;
    if (overwriteSettingsDoc) {
      try {
        overwriteSettings = jsyaml.load(overwriteSettingsDoc);
        $.extend(true, ELA.settings, overwriteSettings);
      } catch (error) {
        alert("Warning: settings.overwrite.yml does not contain valid YAML.");
      }
    }
    return ELA.loadedData = true;
  };

  maybeLoadedAjaxData = function() {
    if (isDocumentReady) {
      if (!_.findWhere(_.values(ajaxFiles), {
        loaded: false
      })) {
        processAjaxData();
        return startApp();
      }
    }
  };

  $(document).ready(function() {
    isDocumentReady = true;
    return maybeLoadedAjaxData();
  });

  fn = function(ajaxFile, state) {
    return $.ajax(ajaxFile, {
      success: function(data) {
        state.loaded = true;
        return state.content = data;
      },
      error: function() {
        if (state.optional) {
          return state.loaded = true;
        } else {
          return alert("Error: Failed to load " + ajaxFile + ".");
        }
      },
      complete: maybeLoadedAjaxData
    });
  };
  for (ajaxFile in ajaxFiles) {
    state = ajaxFiles[ajaxFile];
    fn(ajaxFile, state);
  }

}).call(this);
