(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  if (ELA.Collections == null) {
    ELA.Collections = {};
  }

  ELA.Collections.LimitedCollection = (function(superClass) {
    extend(LimitedCollection, superClass);

    LimitedCollection.prototype.attribute = 'selected';

    LimitedCollection.prototype.limit = 0;

    LimitedCollection.prototype.activeState = true;

    function LimitedCollection() {
      var args, i, options;
      args = 2 <= arguments.length ? slice.call(arguments, 0, i = arguments.length - 1) : (i = 0, []), options = arguments[i++];
      if (options == null) {
        options = {};
      }
      LimitedCollection.__super__.constructor.apply(this, arguments);
      if (options.limit != null) {
        this.limit = options.limit;
      }
      if (options.attribute != null) {
        this.attribute = options.attribute;
      }
      if (options.activeState != null) {
        this.activeState = options.activeState;
      }
      this.history = [];
      this.on("change:" + this.attribute, this.manageHistory);
      this.on('add', this.manageHistory);
      this.on('remove', this.removeFromHistory);
      this.on('reset', this.rebuildHistory);
      this.rebuildHistory();
    }

    LimitedCollection.prototype.getHistory = function() {
      return this.history;
    };

    LimitedCollection.prototype.whereInHistory = function() {
      var filter;
      filter = {};
      filter[this.attribute] = this.activeState;
      return this.where(filter);
    };

    LimitedCollection.prototype.getOldest = function() {
      return this.history[0];
    };

    LimitedCollection.prototype.atLimit = function() {
      if (this.limit > 0) {
        return this.history.length >= this.limit;
      }
    };

    LimitedCollection.prototype.inHistory = function(model) {
      return this.history.indexOf(model) !== -1;
    };

    LimitedCollection.prototype.removeFromHistory = function(model) {
      var results;
      results = [];
      while (this.inHistory(model)) {
        this.history.splice(this.history.indexOf(model), 1);
        results.push(this.trigger('historyChange'));
      }
      return results;
    };

    LimitedCollection.prototype.rebuildHistory = function() {
      var oldHistory;
      oldHistory = _.clone(this.history);
      this.history = [];
      this.each((function(_this) {
        return function(model) {
          return _this.manageHistory(model, {
            silent: true
          });
        };
      })(this));
      if (!_.isEqual(oldHistory, this.history)) {
        return this.trigger('historyChange');
      }
    };

    LimitedCollection.prototype.manageHistory = function(model, options) {
      if (options == null) {
        options = {};
      }
      if (model.get(this.attribute) === this.activeState) {
        if (!this.inHistory(model)) {
          while (this.atLimit()) {
            this.history.shift().set(this.attribute, !this.activeState);
          }
          this.history.push(model);
          if (!options.silent) {
            this.trigger('historyChange');
          }
        }
      } else {
        this.removeFromHistory(model);
      }
      return this;
    };

    return LimitedCollection;

  })(Backbone.Collection);

}).call(this);
