(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Models == null) {
    ELA.Models = {};
  }

  ELA.Models.BaseAppModel = (function(superClass) {
    extend(BaseAppModel, superClass);

    function BaseAppModel() {
      return BaseAppModel.__super__.constructor.apply(this, arguments);
    }

    BaseAppModel.prototype.localePrefix = function(append) {
      var path, prefixes;
      if (append == null) {
        append = null;
      }
      prefixes = [];
      path = this.path.split('/');
      if (append != null) {
        path.push(append);
      }
      while (!(path.length < 1)) {
        prefixes.push(path.join('.'));
        path.pop();
      }
      if (prefixes.length <= 0) {
        return null;
      } else if (prefixes.length === 1) {
        return prefixes[0];
      } else {
        return prefixes;
      }
    };

    BaseAppModel.prototype.loadSettings = function(type, key, defaults) {
      var base, name, settings;
      if (defaults == null) {
        defaults = {};
      }
      this.settings || (this.settings = {});
      settings = (base = this.settings)[name = type + "_" + key] || (base[name] = (function(_this) {
        return function() {
          var component, i, len, pathComponents, ref, step;
          settings = {};
          pathComponents = _this.path.split('/');
          while (!(pathComponents.length < 1)) {
            step = ELA.settings;
            for (i = 0, len = pathComponents.length; i < len; i++) {
              component = pathComponents[i];
              if (step != null) {
                step = step[component];
              }
            }
            if ((type != null) && (key != null)) {
              settings = $.extend(step != null ? (ref = step[type]) != null ? ref[key] : void 0 : void 0, settings);
            } else {
              settings = $.extend(step != null ? step[type] : void 0, settings);
            }
            pathComponents.pop();
          }
          return settings;
        };
      })(this)());
      return $.extend(settings, defaults);
    };

    BaseAppModel.prototype.defaults = function() {
      return this.loadSettings('defaults');
    };

    BaseAppModel.prototype.loadFormFieldSettings = function(attribute, defaults) {
      if (defaults == null) {
        defaults = {};
      }
      defaults.attribute = attribute;
      return this.loadSettings('formFields', attribute, defaults);
    };

    BaseAppModel.prototype.loadCurveSettings = function(fun, defaults) {
      if (defaults == null) {
        defaults = {};
      }
      defaults["function"] = fun;
      return this.loadSettings('curves', fun, defaults);
    };

    return BaseAppModel;

  })(Backbone.Model);

}).call(this);
