(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Views == null) {
    ELA.Views = {};
  }

  ELA.Views.BaseSubappContainer = (function(superClass) {
    extend(BaseSubappContainer, superClass);

    function BaseSubappContainer() {
      this.render = bind(this.render, this);
      this.toggleActivation = bind(this.toggleActivation, this);
      this.deactivate = bind(this.deactivate, this);
      this.activate = bind(this.activate, this);
      this.setActive = bind(this.setActive, this);
      this.remove = bind(this.remove, this);
      return BaseSubappContainer.__super__.constructor.apply(this, arguments);
    }

    BaseSubappContainer.prototype.id = function() {
      return this.model.name.toDash();
    };

    BaseSubappContainer.prototype.tagName = 'section';

    BaseSubappContainer.prototype.className = 'subapp-container';

    BaseSubappContainer.prototype.subappViews = [];

    BaseSubappContainer.prototype.events = {
      'tap header h2': 'switchSubapp'
    };

    BaseSubappContainer.prototype.initialize = function() {
      BaseSubappContainer.__super__.initialize.apply(this, arguments);
      return this.listenTo(this.model, 'change:path', this.toggleActivation);
    };

    BaseSubappContainer.prototype.remove = function() {
      return this.$el.afterTransitionForRemovingClass('active', (function(_this) {
        return function() {
          return BaseSubappContainer.__super__.remove.apply(_this, arguments);
        };
      })(this));
    };

    BaseSubappContainer.prototype.setActive = function(active) {
      return this.$el.toggleClass('active', active);
    };

    BaseSubappContainer.prototype.activate = function() {
      return this.$el.toggleClass('active', true);
    };

    BaseSubappContainer.prototype.deactivate = function() {
      return this.$el.toggleClass('active', false);
    };

    BaseSubappContainer.prototype.toggleActivation = function() {
      var app, name, ref, results, subapp;
      subapp = this.model.get('path')[0];
      ref = this.model.subapps;
      results = [];
      for (name in ref) {
        app = ref[name];
        results.push(this.subviews[name].setActive(name === subapp));
      }
      return results;
    };

    BaseSubappContainer.prototype.render = function() {
      var SubappView, app, name, ref, view;
      this.$el.empty();
      ref = this.model.subapps;
      for (name in ref) {
        app = ref[name];
        SubappView = app.view.toFunction();
        this.subviews[name] = view = new SubappView({
          model: this.model.subappInstances[name],
          localePrefix: this.localePrefix + "." + name
        });
        this.$el.append(view.render().el);
      }
      this.toggleActivation();
      return this;
    };

    return BaseSubappContainer;

  })(Backbone.Poised.View);

}).call(this);
