(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  if (ELA.Views == null) {
    ELA.Views = {};
  }

  ELA.Views.CurvesAside = (function(superClass) {
    extend(CurvesAside, superClass);

    function CurvesAside() {
      this.render = bind(this.render, this);
      return CurvesAside.__super__.constructor.apply(this, arguments);
    }

    CurvesAside.prototype.initialize = function() {
      if (this.model.curves == null) {
        throw new Error('Missing curves collection in model for CurvesAside');
      }
    };

    CurvesAside.prototype.render = function() {
      this.$el.toggleClass('scroll-y', true);
      this.subviews.curvesList = new Backbone.Poised.List({
        collection: this.model.curves,
        filterAttributes: ['label'],
        itemLabel: JST['general/curves_list_item_label'],
        itemClass: ELA.Views.CurvesListItem,
        singleSelect: true,
        localePrefix: this.model.localePrefix(),
        group: {
          by: 'group'
        }
      });
      this.$el.html(this.subviews.curvesList.render().el);
      this.$el.append($('<div>', {
        "class": 'hint'
      }).text(t('curvesAside.hint')));
      return this;
    };

    return CurvesAside;

  })(ELA.Views.BaseAside);

}).call(this);
