(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Backbone.Poised.LinkedRangeControl = (function(superClass) {
    extend(LinkedRangeControl, superClass);

    function LinkedRangeControl() {
      this.render = bind(this.render, this);
      this.initialize = bind(this.initialize, this);
      return LinkedRangeControl.__super__.constructor.apply(this, arguments);
    }

    LinkedRangeControl.prototype.initialize = function(options) {
      var ref, ref1, ref10, ref11, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9;
      if (options == null) {
        options = {};
      }
      LinkedRangeControl.__super__.initialize.apply(this, arguments);
      this.options = _.chain(options).pick('renderSpinner', 'clearOnFocus', 'stepSize', 'precision', 'range', 'attribute', 'unit', 'sliderMinValue', 'sliderMaxValue', 'spinnerMinValue', 'spinnerMaxValue').defaults({
        renderSpinner: true,
        clearOnFocus: true,
        stepSize: 1,
        precision: _.find([0, 1, 2, 3], function(i) {
          return options.stepSize * Math.pow(10, i) >= 1;
        }),
        type: 'number'
      }).value();
      if (this.options.renderSpinner) {
        this.spinnerOptions = _.chain(this.options).pick('attribute', 'type', 'clearOnFocus', 'unit', 'precision', 'stepSize').defaults({
          minValue: _.firstDefined(this.options.spinnerMinValue, (ref = this.options.range) != null ? ref[0] : void 0, (ref1 = this.options.range) != null ? (ref2 = ref1.spinner) != null ? ref2[0] : void 0 : void 0),
          maxValue: _.firstDefined(this.options.spinnerMaxValue, (ref3 = this.options.range) != null ? ref3[1] : void 0, (ref4 = this.options.range) != null ? (ref5 = ref4.spinner) != null ? ref5[1] : void 0 : void 0),
          parentView: this
        }).value();
      }
      return this.sliderOptions = _.chain(this.options).pick('attribute', 'stepSize').defaults({
        minValue: _.firstDefined(this.options.sliderMinValue, (ref6 = this.options.range) != null ? ref6[0] : void 0, (ref7 = this.options.range) != null ? (ref8 = ref7.slider) != null ? ref8[0] : void 0 : void 0),
        maxValue: _.firstDefined(this.options.sliderMaxValue, (ref9 = this.options.range) != null ? ref9[1] : void 0, (ref10 = this.options.range) != null ? (ref11 = ref10.slider) != null ? ref11[1] : void 0 : void 0),
        parentView: this
      }).value();
    };

    LinkedRangeControl.prototype.render = function() {
      LinkedRangeControl.__super__.render.apply(this, arguments);
      if (this.options.renderSpinner) {
        this.subviews.spinner1 = new Backbone.Poised.Textfield(_.defaults({
          model: this.model1
        }, this.spinnerOptions));
        this.$control1.append(this.subviews.spinner1.render().el);
        this.subviews.spinner2 = new Backbone.Poised.Textfield(_.defaults({
          model: this.model2
        }, this.spinnerOptions));
        this.$control2.append(this.subviews.spinner2.render().el);
      } else {
        this.subviews.value1 = new Backbone.Poised.Value(_.defaults({
          model: this.model1
        }, this.options));
        this.$control1.append(this.subviews.value1.render().el);
        this.subviews.value2 = new Backbone.Poised.Value(_.defaults({
          model: this.model2
        }, this.options));
        this.$control2.append(this.subviews.value2.render().el);
      }
      this.subviews.slider1 = new Backbone.Poised.Slider(_.defaults({
        model: this.model1
      }, this.spinnerOptions));
      this.$control1.append(this.subviews.slider1.render().el);
      this.subviews.slider2 = new Backbone.Poised.Slider(_.defaults({
        model: this.model2
      }, this.spinnerOptions));
      this.$control2.append(this.subviews.slider2.render().el);
      return this;
    };

    return LinkedRangeControl;

  })(Backbone.Poised.LinkedControl);

}).call(this);
