(function() {
  var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Backbone.Poised.Textarea = (function(superClass) {
    extend(Textarea, superClass);

    function Textarea() {
      this.render = bind(this.render, this);
      this.updateTextareaValue = bind(this.updateTextareaValue, this);
      this.updateAttributeValue = bind(this.updateAttributeValue, this);
      this.initialize = bind(this.initialize, this);
      return Textarea.__super__.constructor.apply(this, arguments);
    }

    Textarea.prototype.tagName = 'span';

    Textarea.prototype.className = 'poised textarea';

    Textarea.prototype.events = {
      'input textarea': 'updateAttributeValue'
    };

    Textarea.prototype.initialize = function(options) {
      if (options == null) {
        options = {};
      }
      if (options.model == null) {
        throw new Error('Missing `model` option');
      }
      if (options.attribute == null) {
        throw new Error('Missing `attribute` option');
      }
      this.options = _.chain(options).pick('rows', 'placeholder').defaults({
        rows: 3,
        placeholder: null
      }).value();
      this.attribute = options.attribute;
      return this.model.on("change:" + this.attribute, this.render);
    };

    Textarea.prototype.updateAttributeValue = function() {
      return this.model.set(this.attribute, this.$textarea.val());
    };

    Textarea.prototype.updateTextareaValue = function(model, value) {
      var val;
      val = value || this.model.get(this.attribute);
      return this.$textarea.val(val);
    };

    Textarea.prototype.render = function() {
      this.$textarea = $('<textarea>', this.options);
      this.$el.html(this.$textarea);
      this.updateTextareaValue();
      return this;
    };

    return Textarea;

  })(Backbone.Poised.View);

}).call(this);
