(function() {
  var base,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  (base = Backbone.Poised).List || (base.List = {});

  Backbone.Poised.List.Anchor = (function(superClass) {
    extend(Anchor, superClass);

    function Anchor() {
      this.toggleCollapse = bind(this.toggleCollapse, this);
      return Anchor.__super__.constructor.apply(this, arguments);
    }

    Anchor.prototype.tagName = 'li';

    Anchor.prototype.className = 'anchor';

    Anchor.prototype.events = {
      'click': 'toggleCollapse'
    };

    Anchor.prototype.initialize = function(options) {
      if (options == null) {
        options = {};
      }
      Anchor.__super__.initialize.apply(this, arguments);
      this.name = options.name || 'general';
      this.label = options.label;
      this.collapsible = options.collapsible === true;
      if (this.collapsible) {
        return this.collapsed = options.collapsed !== false;
      }
    };

    Anchor.prototype.toggleCollapse = function() {
      return this.$el.toggleClass('collapsed');
    };

    Anchor.prototype.render = function() {
      var defaultLocale;
      if (this.name === 'undefined') {
        defaultLocale = 'other';
      } else {
        defaultLocale = this.name.toLabel();
      }
      this.$el.html(this.loadLocale("listAnchors." + this.name + ".label", {
        defaultValue: defaultLocale
      }));
      if (this.collapsible) {
        this.$el.addClass('collapsible');
        if (this.collapsed) {
          this.toggleCollapse();
        }
      }
      return this;
    };

    return Anchor;

  })(Backbone.Poised.View);

}).call(this);
